/*
	Pscmd
	--------
	License     	Apache 2.0 License
	--------
	Copyright 2018 SMALLSO Studios.

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

		http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
	------
	E-mail      	xiaoyy@altca.cn
	WorkQQ   	20177621
	Website   	https://www.xiaoyy.org/
	------
	SMALLSO Studios.
	2018/5/17 22:08
*/

#include "stdafx.h"
#include "pscmd.h"

/* NTAPI ZwQueryInformationProcess */
typedef NTSTATUS(NTAPI * Typedef_ZwQueryInformationProcess)(HANDLE, PROCESSINFOCLASS, PVOID, ULONG, PULONG);
Typedef_ZwQueryInformationProcess pNTAPI_ZwQueryInformationProcess =
(Typedef_ZwQueryInformationProcess)GetProcAddress(GetModuleHandle(L"ntdll.dll"), "ZwQueryInformationProcess");

/*
	ȡַָʧܷ FALSEUnicode Version
	--------
	HANDLE hProcess							ȡַĽ̾þӦ PROCESS_QUERY_INFORMATION  PROCESS_VM_READ Ȩ
	LPCWSTR lpcBuffer							ַָĿַָ룬Ӧʹ memset ʼΪ zeroòΪ NULL
	SIZE_T nSize										 lpcBuffer ָĿַЧСBytesòΪ NULL
	SIZE_T* lpNumberOfBytesCopied	ʵʸƵ lpcBuffer ָĿַеֽBytes lpcBuffer Ϊ NULL  nSize ̫Сò軺ĽСBytesòΪ NULL
*/
BOOL WINAPI GetProcessCommandLineW(HANDLE hProcess, LPCWSTR lpcBuffer, SIZE_T nSize, SIZE_T* lpNumberOfBytesCopied)
{
	BOOL result = FALSE;
	if (pNTAPI_ZwQueryInformationProcess)
	{
		PROCESS_BASIC_INFORMATION BasicInfo; memset(&BasicInfo, NULL, sizeof(BasicInfo));
		PEB PebBaseInfo; memset(&PebBaseInfo, NULL, sizeof(PebBaseInfo));
		RTL_USER_PROCESS_PARAMETERS ProcessParameters; memset(&ProcessParameters, NULL, sizeof(ProcessParameters));
		if (pNTAPI_ZwQueryInformationProcess(hProcess, PROCESSINFOCLASS::ProcessBasicInformation, &BasicInfo, sizeof(BasicInfo), NULL) == STATUS_SUCCESS)
		{
			if (ReadProcessMemory(hProcess, BasicInfo.PebBaseAddress, &PebBaseInfo, sizeof(PebBaseInfo), NULL)
				&& ReadProcessMemory(hProcess, PebBaseInfo.ProcessParameters, &ProcessParameters, sizeof(ProcessParameters), NULL))
			{
				if (lpcBuffer && nSize >= ProcessParameters.CommandLine.Length + 2)
					result = ReadProcessMemory(hProcess, ProcessParameters.CommandLine.Buffer, (LPVOID)lpcBuffer,
						ProcessParameters.CommandLine.Length, lpNumberOfBytesCopied);
				else if (lpNumberOfBytesCopied) { *lpNumberOfBytesCopied = ProcessParameters.CommandLine.Length + 2; result = TRUE; }
			}
		}
	}
	return result;
}

/*
	ȡַָʧܷ FALSEAnsi Version
	--------
	GetProcessCommandLineA ǻ GetProcessCommandLineW  Ansi 汾ӦóӦʹ GetProcessCommandLineWǴ GetProcessCommandLineA
	--------
	HANDLE hProcess							ȡַĽ̾þӦ PROCESS_QUERY_INFORMATION  PROCESS_VM_READ Ȩ
	LPCWSTR lpcBuffer							ַָĶֽڻָ룬Ӧʹ memset ʼΪ zeroòΪ NULL
	SIZE_T nSize										 lpcBuffer ָĶֽڻЧСBytesòΪ NULL
	SIZE_T* lpNumberOfBytesCopied	ʵʸƵ lpcBuffer ָĶֽڻеֽBytes lpcBuffer Ϊ NULL  nSize ̫Сò軺ĽСBytesòΪ NULL
*/
BOOL WINAPI GetProcessCommandLineA(HANDLE hProcess, LPCSTR lpcBuffer, SIZE_T nSize, SIZE_T* lpNumberOfBytesCopied)
{
	BOOL result = FALSE;
	SIZE_T nCommandLineSize = NULL;
	if (GetProcessCommandLineW(hProcess, NULL, NULL, &nCommandLineSize))
	{
		WCHAR* lpLocalBuffer = (WCHAR*)malloc(nCommandLineSize);
		if (lpLocalBuffer)
		{
			memset(lpLocalBuffer, NULL, nCommandLineSize);
			if (GetProcessCommandLineW(hProcess, lpLocalBuffer, nCommandLineSize, &nCommandLineSize))
			{
				INT iNumberOfBytes = WideCharToMultiByte(CP_ACP, NULL, lpLocalBuffer, nCommandLineSize, (LPSTR)lpcBuffer, nSize, NULL, NULL);
				if (lpNumberOfBytesCopied) *lpNumberOfBytesCopied = (!lpcBuffer || (nSize < (iNumberOfBytes + 1))) ?  iNumberOfBytes + 1 : iNumberOfBytes;
				result = iNumberOfBytes > 0;
			}
			free(lpLocalBuffer);
		}
	}
	return result;
}
